/*
 =================== DO NOT EDIT THIS FILE ====================
 Generated by Modello 1.0.1 on 2009-08-06 15:13:09,
 any modifications will be overwritten.
 ==============================================================
 */

package org.apache.maven.model;

/**
 * 
 *         
 *         The <code>&lt;CiManagement&gt;</code> element contains
 * informations required to the
 *         continuous integration system of the project.
 *         
 *       
 * 
 * @version $Revision$ $Date$
 */
public class CiManagement
    implements java.io.Serializable
{

      //--------------------------/
     //- Class/Member Variables -/
    //--------------------------/

    /**
     * 
     *             
     *             The name of the continuous integration system,
     * e.g. <code>continuum</code>.
     *             
     *           
     */
    private String system;

    /**
     * URL for the continuous integration system used by the
     * project if it has a web
     *             interface.
     */
    private String url;

    /**
     * Field notifiers.
     */
    private java.util.List<Notifier> notifiers;


      //-----------/
     //- Methods -/
    //-----------/

    /**
     * Method addNotifier.
     * 
     * @param notifier
     */
    public void addNotifier( Notifier notifier )
    {
        if ( !(notifier instanceof Notifier) )
        {
            throw new ClassCastException( "CiManagement.addNotifiers(notifier) parameter must be instanceof " + Notifier.class.getName() );
        }
        getNotifiers().add( notifier );
    } //-- void addNotifier( Notifier )

    /**
     * Method getNotifiers.
     * 
     * @return List
     */
    public java.util.List<Notifier> getNotifiers()
    {
        if ( this.notifiers == null )
        {
            this.notifiers = new java.util.ArrayList<Notifier>();
        }

        return this.notifiers;
    } //-- java.util.List<Notifier> getNotifiers()

    /**
     * Get the name of the continuous integration system, e.g.
     * <code>continuum</code>.
     * 
     * @return String
     */
    public String getSystem()
    {
        return this.system;
    } //-- String getSystem()

    /**
     * Get uRL for the continuous integration system used by the
     * project if it has a web
     *             interface.
     * 
     * @return String
     */
    public String getUrl()
    {
        return this.url;
    } //-- String getUrl()

    /**
     * Method removeNotifier.
     * 
     * @param notifier
     */
    public void removeNotifier( Notifier notifier )
    {
        if ( !(notifier instanceof Notifier) )
        {
            throw new ClassCastException( "CiManagement.removeNotifiers(notifier) parameter must be instanceof " + Notifier.class.getName() );
        }
        getNotifiers().remove( notifier );
    } //-- void removeNotifier( Notifier )

    /**
     * Set configuration for notifying developers/users when a
     * build is unsuccessful,
     *             including user information and notification
     * mode.
     * 
     * @param notifiers
     */
    public void setNotifiers( java.util.List<Notifier> notifiers )
    {
        this.notifiers = notifiers;
    } //-- void setNotifiers( java.util.List )

    /**
     * Set the name of the continuous integration system, e.g.
     * <code>continuum</code>.
     * 
     * @param system
     */
    public void setSystem( String system )
    {
        this.system = system;
    } //-- void setSystem( String )

    /**
     * Set uRL for the continuous integration system used by the
     * project if it has a web
     *             interface.
     * 
     * @param url
     */
    public void setUrl( String url )
    {
        this.url = url;
    } //-- void setUrl( String )


}
