/*
 =================== DO NOT EDIT THIS FILE ====================
 Generated by Modello 1.0.1 on 2009-08-06 15:13:09,
 any modifications will be overwritten.
 ==============================================================
 */

package org.apache.maven.model;

/**
 * Section for management of reports and their configuration.
 * 
 * @version $Revision$ $Date$
 */
public class Reporting
    implements java.io.Serializable
{

      //--------------------------/
     //- Class/Member Variables -/
    //--------------------------/

    /**
     * If true, then the default reports are not included in the
     * site generation.
     *             This includes the reports in the "Project Info"
     * menu.
     */
    private Boolean excludeDefaultsValue;

    /**
     * 
     *             
     *             Where to store all of the generated reports. The
     * default is
     *             <code>${project.build.directory}/site</code>
     *             .
     *             
     *           
     */
    private String outputDirectory;

    /**
     * Field plugins.
     */
    private java.util.List<ReportPlugin> plugins;


      //-----------/
     //- Methods -/
    //-----------/

    /**
     * Method addPlugin.
     * 
     * @param reportPlugin
     */
    public void addPlugin( ReportPlugin reportPlugin )
    {
        if ( !(reportPlugin instanceof ReportPlugin) )
        {
            throw new ClassCastException( "Reporting.addPlugins(reportPlugin) parameter must be instanceof " + ReportPlugin.class.getName() );
        }
        getPlugins().add( reportPlugin );
    } //-- void addPlugin( ReportPlugin )

    /**
     * Get where to store all of the generated reports. The default
     * is
     *             <code>${project.build.directory}/site</code>
     *             .
     * 
     * @return String
     */
    public String getOutputDirectory()
    {
        return this.outputDirectory;
    } //-- String getOutputDirectory()

    /**
     * Method getPlugins.
     * 
     * @return List
     */
    public java.util.List<ReportPlugin> getPlugins()
    {
        if ( this.plugins == null )
        {
            this.plugins = new java.util.ArrayList<ReportPlugin>();
        }

        return this.plugins;
    } //-- java.util.List<ReportPlugin> getPlugins()

    /**
     * Get if true, then the default reports are not included in
     * the site generation.
     *             This includes the reports in the "Project Info"
     * menu.
     * 
     * @return Boolean
     */
    public Boolean isExcludeDefaultsValue()
    {
        return this.excludeDefaultsValue;
    } //-- Boolean isExcludeDefaultsValue()

    /**
     * Method removePlugin.
     * 
     * @param reportPlugin
     */
    public void removePlugin( ReportPlugin reportPlugin )
    {
        if ( !(reportPlugin instanceof ReportPlugin) )
        {
            throw new ClassCastException( "Reporting.removePlugins(reportPlugin) parameter must be instanceof " + ReportPlugin.class.getName() );
        }
        getPlugins().remove( reportPlugin );
    } //-- void removePlugin( ReportPlugin )

    /**
     * Set if true, then the default reports are not included in
     * the site generation.
     *             This includes the reports in the "Project Info"
     * menu.
     * 
     * @param excludeDefaultsValue
     */
    public void setExcludeDefaultsValue( Boolean excludeDefaultsValue )
    {
        this.excludeDefaultsValue = excludeDefaultsValue;
    } //-- void setExcludeDefaultsValue( Boolean )

    /**
     * Set where to store all of the generated reports. The default
     * is
     *             <code>${project.build.directory}/site</code>
     *             .
     * 
     * @param outputDirectory
     */
    public void setOutputDirectory( String outputDirectory )
    {
        this.outputDirectory = outputDirectory;
    } //-- void setOutputDirectory( String )

    /**
     * Set the reporting plugins to use and their configuration.
     * 
     * @param plugins
     */
    public void setPlugins( java.util.List<ReportPlugin> plugins )
    {
        this.plugins = plugins;
    } //-- void setPlugins( java.util.List )


            
    java.util.Map reportPluginMap;

    /**
     * Reset the <code>reportPluginMap</code> field to <code>null</code>
     */
    public void flushReportPluginMap()
    {
        this.reportPluginMap = null;
    }

    /**
     * @return a Map of plugins field with <code>ReportPlugin#getKey()</code> as key
     * @see org.apache.maven.model.ReportPlugin#getKey()
     */
    public java.util.Map getReportPluginsAsMap()
    {
        if ( reportPluginMap == null )
        {
            reportPluginMap = new java.util.LinkedHashMap();
            if ( getPlugins() != null )
            {
                for ( java.util.Iterator it = getPlugins().iterator(); it.hasNext(); )
                {
                    ReportPlugin reportPlugin = (ReportPlugin) it.next();
                    reportPluginMap.put( reportPlugin.getKey(), reportPlugin );
                }
            }
        }

        return reportPluginMap;
    }

    public boolean isExcludeDefaults()
    {
        return excludeDefaultsValue != null ? excludeDefaultsValue.booleanValue() : false;
    }

    public void setExcludeDefaults( boolean excludeDefaults )
    {
        excludeDefaultsValue = excludeDefaults ? Boolean.TRUE : Boolean.FALSE;
    }

    public void setExcludeDefaultsValue( String excludeDefaults )
    {
        excludeDefaultsValue = excludeDefaults != null ? Boolean.valueOf( excludeDefaults ) : null;
    }
            
          
}
